#ifndef _COMPLEXCLASSBYGORONKOV
#define _COMPLEXCLASSBYGORONKOV

#include "math.h"

class Complex
{
	public:
   double x;
   double y;

   Complex():x(0), y(0) {};
   Complex(double Re, double Im): x(Re), y(Im) {};
   Complex(double Re): x(Re), y(0) {};

   //---Functions-------------------------------------------------------------
   friend double abs(Complex);
   friend Complex exp(Complex);

   //---Operators-------------------------------------------------------------
   friend Complex operator *(double, Complex);
   friend Complex operator *(Complex, double);
   friend Complex operator +(double, Complex);
   friend Complex operator +(Complex, double);

   Complex operator - ()
   {
    return Complex(-this->x, -this->y);
   }

   Complex &operator += (Complex z)
   {
    x += z.x;
    y += z.y;
    return *this;
   }

   Complex &operator += (double a)
   {
    x += a;
    return *this;
   }

   Complex Complex::operator +(Complex z)
	{
	 return Complex(this->x+z.x,this->y+z.y);
	}

   Complex Complex::operator *(Complex z)
	{
	 return Complex(this->x*z.x-this->y*z.y,this->x*z.y+this->y*z.x);;
	}
};
//--Implementations for class functions---------------------
double abs(Complex z)
{
 return (sqrt(z.x*z.x+z.y*z.y));
}

Complex exp(Complex z)
	{
	 Complex Zr;
	 Zr.x = exp(z.x)*cos(z.y);
	 Zr.y = exp(z.x)*sin(z.y);
	 return Zr;
	}

Complex operator +(double a,Complex z)
	{
	 return Complex(z.x+a,z.y);
	}

Complex operator +(Complex z,double a)
	{
	 return Complex(z.x+a,z.y);
	}

Complex operator *(double a, Complex z)
	{
    return Complex(a*z.x,a*z.y) ;
	}

Complex operator *(Complex z, double a)
	{
    return Complex(a*z.x,a*z.y) ;
	}
#endif





